# -*- coding: utf-8 -*-
#
# Copyright 2004-2006 André Malo or his licensors, as applicable
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""
Package svnmailer_test.suite

@var _modules_: The list of test modules (in order to be applied)
@type _modules_: C{list} or C{module}

@var _suites_: The list of test module names (in order)
@type _suites_: C{list} of C{str}

@var _suitedict_: The map module name -> module
@type _suitedict_: C{dict}
"""
__author__    = "André Malo"
__docformat__ = "epytext en"
__all__       = ['_modules_', '_suites_', '_suitedict_']

suites__ = [
    'util',
    'typedstruct',
    'struct_accessors',
    'settings',
    'cli',
    'config',
    'differ',
    'subversion',
    'stream',
    'browser',
    'notifier',
    'main',
]


_modules_ = []
_suites_ = []
_suitedict_ = {}
for _name_ in suites__:
    _mod_ = __import__(__name__, globals(), locals(), [_name_])
    # package
    if hasattr(getattr(_mod_, _name_), '_suites_'):
        _suites_.extend([
            "%s.%s" % (_name_, test__)
            for test__ in getattr(getattr(_mod_, _name_), '_suites_')
        ])
        _modules_.extend(getattr(getattr(_mod_, _name_), '_modules_'))
        _suitedict_.update(dict([
            ("%s.%s" % (_name_, test__), module__)
            for test__, module__ in
            getattr(getattr(_mod_, _name_), '_suitedict_').items()
        ]))
        del test__, module__
    # module
    else:
        _suites_.append(_name_)
        _modules_.append(getattr(_mod_, _name_))
        _suitedict_[_name_] = _modules_[-1]

del _mod_, _name_, suites__
